Index: protocols/jabber/jabber.c
===================================================================
--- protocols/jabber/jabber.c	(revision a51be6448b7a6aa100f27873ce40b835068a66a7)
+++ protocols/jabber/jabber.c	(revision 0fd8559c4a6ad84ad0852e07c4ba2e50b2fdf0ad)
@@ -1511,882 +52,345 @@
 	s = set_add( &acc->set, "ssl", "false", set_eval_bool, acc );
 	s->flags |= ACC_SET_OFFLINE_ONLY;
-}
-
-static void jabber_login(account_t *acc)
-{
-	struct gaim_connection *gc;
-	struct jabber_data *jd;
-	char *resource, *loginname;
-	
-	/* Time to move some data/things from the old syntax to the new one: */
-	if (acc->server) {
-		char *s, *tmp_server;
-		int port;
-		
-		if (g_strcasecmp(acc->server, "ssl") == 0) {
-			set_setstr(&acc->set, "server", "");
-			set_setint(&acc->set, "port", DEFAULT_PORT_SSL);
-			set_setstr(&acc->set, "ssl", "true");
-			
-			g_free(acc->server);
-			acc->server = NULL;
-		} else if ((s = strchr(acc->server, ':'))) {
-			if (strstr(acc->server, ":ssl")) {
-				set_setint(&acc->set, "port", DEFAULT_PORT_SSL);
-				set_setstr(&acc->set, "ssl", "true");
-			}
-			if (isdigit(s[1])) {
-				if (sscanf(s + 1, "%d", &port) == 1)
-					set_setint(&acc->set, "port", port);
-			}
-			tmp_server = g_strndup(acc->server, s - acc->server);
-			set_setstr(&acc->set, "server", tmp_server);
-			g_free(tmp_server);
-		}
-	}
-	
-	gc = new_gaim_conn(acc);
-	jd = gc->proto_data = g_new0(struct jabber_data, 1);
-	
-	if( strchr( acc->user, '@' ) == NULL )
-	{
-		hide_login_progress( gc, "Invalid account name" );
+	
+	s = set_add( &acc->set, "tls", "try", set_eval_tls, acc );
+	s->flags |= ACC_SET_OFFLINE_ONLY;
+}
+
+static void jabber_login( account_t *acc )
+{
+	struct gaim_connection *gc = new_gaim_conn( acc );
+	struct jabber_data *jd = g_new0( struct jabber_data, 1 );
+	struct ns_srv_reply *srv = NULL;
+	char *connect_to, *s;
+	
+	jd->gc = gc;
+	gc->proto_data = jd;
+	
+	jd->username = g_strdup( acc->user );
+	jd->server = strchr( jd->username, '@' );
+	
+	if( jd->server == NULL )
+	{
+		hide_login_progress( gc, "Incomplete account name (format it like <username@jabberserver.name>)" );
 		signoff( gc );
 		return;
 	}
 	
-	resource = set_getstr(&acc->set, "resource");
-	loginname = create_valid_jid(acc->user, DEFAULT_SERVER, resource);
-	
-	jd->hash = g_hash_table_new(g_str_hash, g_str_equal);
-	jd->chats = NULL;	/* we have no chats yet */
-
-	set_login_progress(gc, 1, _("Connecting"));
-
-	if (!(jd->gjc = gjab_new(loginname, acc->pass, gc))) {
-		g_free(loginname);
-		hide_login_progress(gc, _("Unable to connect"));
-		signoff(gc);
-		return;
-	}
-
-	g_free(loginname);
-	gjab_state_handler(jd->gjc, jabber_handlestate);
-	gjab_packet_handler(jd->gjc, jabber_handlepacket);
-	jd->gjc->queries = g_hash_table_new(g_str_hash, g_str_equal);
-	gjab_start(jd->gjc);
-}
-
-static gboolean jabber_destroy_hash(gpointer key, gpointer val, gpointer data) {
-   	g_free(key);
-	g_free(val);
-	return TRUE;
-}
-
-static gboolean jabber_free(gpointer data, gint fd, b_input_condition cond)
-{
-	struct jabber_data *jd = data;
-
-	if(jd->gjc != NULL) {
-		gjab_delete(jd->gjc);
-		/* YAY for modules with their own memory pool managers!...
-		g_free(jd->gjc->sid);
-		And a less sarcastic yay for valgrind. :-) */
-		jd->gjc = NULL;
-	}
-	g_free(jd);
-
-	return FALSE;
-}
-
-static void jabber_close(struct gaim_connection *gc)
-{
-	struct jabber_data *jd = gc->proto_data;
-
-	if(jd) {
-		GSList *jcs = jd->chats;
-
-		/* Free-up the jabber_chat struct allocs and the list */
-		while (jcs) {
-			g_free(jcs->data);
-			jcs = jcs->next;
+	/* So don't think of free()ing jd->server.. :-) */
+	*jd->server = 0;
+	jd->server ++;
+	
+	if( ( s = strchr( jd->server, '/' ) ) )
+	{
+		*s = 0;
+		set_setstr( &acc->set, "resource", s + 1 );
+		
+		/* Also remove the /resource from the original variable so we
+		   won't have to do this again every time. */
+		s = strchr( acc->user, '/' );
+		*s = 0;
+	}
+	
+	/* This code isn't really pretty. Backwards compatibility never is... */
+	s = acc->server;
+	while( s )
+	{
+		static int had_port = 0;
+		
+		if( strncmp( s, "ssl", 3 ) == 0 )
+		{
+			set_setstr( &acc->set, "ssl", "true" );
+			
+			/* Flush this part so that (if this was the first
+			   part of the server string) acc->server gets
+			   flushed. We don't want to have to do this another
+			   time. :-) */
+			*s = 0;
+			s ++;
+			
+			/* Only set this if the user didn't specify a custom
+			   port number already... */
+			if( !had_port )
+				set_setint( &acc->set, "port", 5223 );
 		}
-		g_slist_free(jd->chats);
-
-		/* Free-up the away status memories and the list */
-		if(jd->hash != NULL) {
-			g_hash_table_foreach_remove(jd->hash, jabber_destroy_hash, NULL);
-			g_hash_table_destroy(jd->hash);
-			jd->hash = NULL;
+		else if( isdigit( *s ) )
+		{
+			int i;
+			
+			/* The first character is a digit. It could be an
+			   IP address though. Only accept this as a port#
+			   if there are only digits. */
+			for( i = 0; isdigit( s[i] ); i ++ );
+			
+			/* If the first non-digit character is a colon or
+			   the end of the string, save the port number
+			   where it should be. */
+			if( s[i] == ':' || s[i] == 0 )
+			{
+				sscanf( s, "%d", &i );
+				set_setint( &acc->set, "port", i );
+				
+				/* See above. */
+				*s = 0;
+				s ++;
+			}
+			
+			had_port = 1;
 		}
-
-		/* Free-up the pending queries memories and the list */
-		if(jd->gjc != NULL && jd->gjc->queries != NULL) {
-			g_hash_table_foreach_remove(jd->gjc->queries, jabber_destroy_hash, NULL);
-			g_hash_table_destroy(jd->gjc->queries);
-			jd->gjc->queries = NULL;
+		
+		s = strchr( s, ':' );
+		if( s )
+		{
+			*s = 0;
+			s ++;
 		}
 	}
-	if (gc->inpa)
-		b_event_remove(gc->inpa);
-
-	if(jd) {
-		b_timeout_add(50, jabber_free, jd);
-		if(jd->gjc != NULL)
-			xmlnode_free(jd->gjc->current);
-	}
-	gc->proto_data = NULL;
-}
-
-static int jabber_send_im(struct gaim_connection *gc, char *who, char *message, int len, int flags)
-{
-	xmlnode x, y;
-	char *realwho;
-	gjconn gjc = ((struct jabber_data *)gc->proto_data)->gjc;
-
-	if (!who || !message)
+	
+	jd->node_cache = g_hash_table_new_full( g_str_hash, g_str_equal, NULL, jabber_cache_entry_free );
+	jd->buddies = g_hash_table_new( g_str_hash, g_str_equal );
+	
+	/* Figure out the hostname to connect to. */
+	if( acc->server && *acc->server )
+		connect_to = acc->server;
+	else if( ( srv = srv_lookup( "xmpp-client", "tcp", jd->server ) ) ||
+		 ( srv = srv_lookup( "jabber-client", "tcp", jd->server ) ) )
+		connect_to = srv->name;
+	else
+		connect_to = jd->server;
+	
+	set_login_progress( gc, 0, "Connecting" );
+	
+	/* For non-SSL connections we can try to use the port # from the SRV
+	   reply, but let's not do that when using SSL, SSL usually runs on
+	   non-standard ports... */
+	if( set_getbool( &acc->set, "ssl" ) )
+	{
+		jd->ssl = ssl_connect( connect_to, set_getint( &acc->set, "port" ), jabber_connected_ssl, gc );
+		jd->fd = jd->ssl ? ssl_getfd( jd->ssl ) : -1;
+	}
+	else
+	{
+		jd->fd = proxy_connect( connect_to, srv ? srv->port : set_getint( &acc->set, "port" ), jabber_connected_plain, gc );
+	}
+	g_free( srv );
+	
+	if( jd->fd == -1 )
+	{
+		hide_login_progress( gc, "Could not connect to server" );
+		signoff( gc );
+	}
+}
+
+static void jabber_close( struct gaim_connection *gc )
+{
+	struct jabber_data *jd = gc->proto_data;
+	
+	jabber_end_stream( gc );
+	
+	if( jd->r_inpa >= 0 )
+		b_event_remove( jd->r_inpa );
+	if( jd->w_inpa >= 0 )
+		b_event_remove( jd->w_inpa );
+	
+	if( jd->ssl )
+		ssl_disconnect( jd->ssl );
+	if( jd->fd >= 0 )
+		closesocket( jd->fd );
+	
+	if( jd->tx_len )
+		g_free( jd->txq );
+	
+	g_hash_table_destroy( jd->node_cache );
+	
+	xt_free( jd->xt );
+	
+	g_free( jd->away_message );
+	g_free( jd->username );
+	g_free( jd );
+}
+
+static int jabber_send_im( struct gaim_connection *gc, char *who, char *message, int len, int away )
+{
+	struct jabber_data *jd = gc->proto_data;
+	struct jabber_buddy *bud;
+	struct xt_node *node;
+	int st;
+	
+	bud = jabber_buddy_by_jid( gc, who, 0 );
+	
+	node = xt_new_node( "body", message, NULL );
+	node = jabber_make_packet( "message", "chat", bud ? bud->full_jid : who, node );
+	
+	if( bud && ( jd->flags & JFLAG_WANT_TYPING ) &&
+	    ( ( bud->flags & JBFLAG_DOES_XEP85 ) ||
+	     !( bud->flags & JBFLAG_PROBED_XEP85 ) ) )
+	{
+		struct xt_node *act;
+		
+		/* If the user likes typing notification and if we don't know
+		   (and didn't probe before) if this resource supports XEP85,
+		   include a probe in this packet now. Also, if we know this
+		   buddy does support XEP85, we have to send this <active/>
+		   tag to tell that the user stopped typing (well, that's what
+		   we guess when s/he pressed Enter...). */
+		act = xt_new_node( "active", NULL, NULL );
+		xt_add_attr( act, "xmlns", XMLNS_CHATSTATES );
+		xt_add_child( node, act );
+		
+		/* Just make sure we do this only once. */
+		bud->flags |= JBFLAG_PROBED_XEP85;
+	}
+	
+	st = jabber_write_packet( gc, node );
+	xt_free_node( node );
+	
+	return st;
+}
+
+static GList *jabber_away_states( struct gaim_connection *gc )
+{
+	static GList *l = NULL;
+	int i;
+	
+	if( l == NULL )
+		for( i = 0; jabber_away_state_list[i].full_name; i ++ )
+			l = g_list_append( l, (void*) jabber_away_state_list[i].full_name );
+	
+	return l;
+}
+
+static void jabber_get_info( struct gaim_connection *gc, char *who )
+{
+	struct jabber_data *jd = gc->proto_data;
+	struct jabber_buddy *bud;
+	
+	if( strchr( who, '/' ) )
+		bud = jabber_buddy_by_jid( gc, who, 0 );
+	else
+	{
+		char *s = jabber_normalize( who );
+		bud = g_hash_table_lookup( jd->buddies, s );
+		g_free( s );
+	}
+	
+	while( bud )
+	{
+		serv_got_crap( gc, "Buddy %s (%d) information:\nAway state: %s\nAway message: %s",
+		                   bud->full_jid, bud->priority,
+		                   bud->away_state ? bud->away_state->full_name : "(none)",
+		                   bud->away_message ? : "(none)" );
+		bud = bud->next;
+	}
+	
+	jabber_get_vcard( gc, bud ? bud->full_jid : who );
+}
+
+static void jabber_set_away( struct gaim_connection *gc, char *state_txt, char *message )
+{
+	struct jabber_data *jd = gc->proto_data;
+	struct jabber_away_state *state;
+	
+	/* Save all this info. We need it, for example, when changing the priority setting. */
+	state = (void *) jabber_away_state_by_name( state_txt );
+	jd->away_state = state ? state : (void *) jabber_away_state_list; /* Fall back to "Away" if necessary. */
+	g_free( jd->away_message );
+	jd->away_message = ( message && *message ) ? g_strdup( message ) : NULL;
+	
+	presence_send_update( gc );
+}
+
+static void jabber_add_buddy( struct gaim_connection *gc, char *who )
+{
+	if( jabber_add_to_roster( gc, who, NULL ) )
+		presence_send_request( gc, who, "subscribe" );
+}
+
+static void jabber_remove_buddy( struct gaim_connection *gc, char *who, char *group )
+{
+	/* We should always do this part. Clean up our administration a little bit. */
+	jabber_buddy_remove_bare( gc, who );
+	
+	if( jabber_remove_from_roster( gc, who ) )
+		presence_send_request( gc, who, "unsubscribe" );
+}
+
+static void jabber_keepalive( struct gaim_connection *gc )
+{
+	/* Just any whitespace character is enough as a keepalive for XMPP sessions. */
+	jabber_write( gc, "\n", 1 );
+	
+	/* This runs the garbage collection every minute, which means every packet
+	   is in the cache for about a minute (which should be enough AFAIK). */
+	jabber_cache_clean( gc );
+}
+
+static int jabber_send_typing( struct gaim_connection *gc, char *who, int typing )
+{
+	struct jabber_data *jd = gc->proto_data;
+	struct jabber_buddy *bud;
+	
+	/* Enable typing notification related code from now. */
+	jd->flags |= JFLAG_WANT_TYPING;
+	
+	if( ( bud = jabber_buddy_by_jid( gc, who, 0 ) ) == NULL )
+	{
+		/* Sending typing notifications to unknown buddies is
+		   unsupported for now. Shouldn't be a problem, I think. */
 		return 0;
-
-	x = xmlnode_new_tag("message");
-	/* Bare username and "username" not the server itself? */
-	if (!strchr(who, '@') && strcmp(who, gjc->user->server) != 0)
-		realwho = g_strdup_printf("%s@%s", who, gjc->user->server);
-	else
-		realwho = g_strdup(who);
-	xmlnode_put_attrib(x, "to", realwho);
-	g_free(realwho);
-
-	xmlnode_insert_tag(x, "bitlbee");
-	xmlnode_put_attrib(x, "type", "chat");
-
-	if (message && strlen(message)) {
-		y = xmlnode_insert_tag(x, "body");
-		xmlnode_insert_cdata(y, message, -1);
-	}
-
-	gjab_send(((struct jabber_data *)gc->proto_data)->gjc, x);
-	xmlnode_free(x);
+	}
+	
+	if( bud->flags & JBFLAG_DOES_XEP85 )
+	{
+		/* We're only allowed to send this stuff if we know the other
+		   side supports it. */
+		
+		struct xt_node *node;
+		char *type;
+		int st;
+		
+		if( typing == 0 )
+			type = "active";
+		else if( typing == 2 )
+			type = "paused";
+		else /* if( typing == 1 ) */
+			type = "composing";
+		
+		node = xt_new_node( type, NULL, NULL );
+		xt_add_attr( node, "xmlns", XMLNS_CHATSTATES );
+		node = jabber_make_packet( "message", "chat", bud->full_jid, node );
+		
+		st = jabber_write_packet( gc, node );
+		xt_free_node( node );
+		
+		return st;
+	}
+	
 	return 1;
 }
 
-/*
- * Add/update buddy's roster entry on server
- */
-static void jabber_roster_update(struct gaim_connection *gc, char *name)
-{
-	xmlnode x, y;
-	char *realwho;
-	gjconn gjc;
-	struct buddy *buddy = NULL;
-	/* struct group *buddy_group = NULL; */
-	
-	if(gc && gc->proto_data && ((struct jabber_data *)gc->proto_data)->gjc && name) {
-		gjc = ((struct jabber_data *)gc->proto_data)->gjc;
-
-		if (!strchr(name, '@'))
-			realwho = g_strdup_printf("%s@%s", name, gjc->user->server);
-		else {
-			jid who = jid_new(gjc->p, name);
-			if (who->user == NULL) {
-				/* FIXME: transport */
-				return;
-			}
-			realwho = g_strdup_printf("%s@%s", who->user, who->server);
-		}
-
-
-		x = jutil_iqnew(JPACKET__SET, NS_ROSTER);
-		y = xmlnode_insert_tag(xmlnode_get_tag(x, "query"), "item");
-		xmlnode_put_attrib(y, "jid", realwho);
-
-
-		/* If we can find the buddy, there's an alias for him, it's not 0-length
-		 * and it doesn't match his JID, add the "name" attribute.
-		 */
-		if((buddy = find_buddy(gc, realwho)) != NULL &&
-			buddy->show != NULL && buddy->show[0] != '\0' && strcmp(realwho, buddy->show)) {
-
-			xmlnode_put_attrib(y, "name", buddy->show);
-		}
-
-		/*
-		 * Find out what group the buddy's in and send that along
-		 * with the roster item.
-		 */
-		/* ** Bitlbee disabled **
-		if((buddy_group = NULL) != NULL) {
-			xmlnode z;
-			z = xmlnode_insert_tag(y, "group");
-			xmlnode_insert_cdata(z, buddy_group->name, -1);
-		}
-		** End - Bitlbee ** */
-
-		gjab_send(((struct jabber_data *)gc->proto_data)->gjc, x);
-
-		xmlnode_free(x);
-		g_free(realwho);
-	}
-}
-
-/*
- * Change buddy's group on server roster
- */
-static void jabber_group_change(struct gaim_connection *gc, char *name, char *old_group, char *new_group)
-{
-	if(strcmp(old_group, new_group)) {
-		jabber_roster_update(gc, name);
-	}
-}
-
-static void jabber_add_buddy(struct gaim_connection *gc, char *name)
-{
-	xmlnode x;
-	char *realwho;
-	gjconn gjc = ((struct jabber_data *)gc->proto_data)->gjc;
-
-	if (!((struct jabber_data *)gc->proto_data)->did_import)
-		return;
-
-	if (!name)
-		return;
-
-	if (!strcmp(gc->username, name))
-		return;
-
-	if (!strchr(name, '@'))
-		realwho = g_strdup_printf("%s@%s", name, gjc->user->server);
-	else {
-		jid who;
-		
-		if((who = jid_new(gjc->p, name)) == NULL) {
-			char *msg = g_strdup_printf("%s: \"%s\"", _("Invalid Jabber I.D."), name);
-			do_error_dialog(GJ_GC(gjc), msg, _("Jabber Error"));
-			g_free(msg);
-			jabber_remove_gaim_buddy(gc, name);
-			return;
-		}
-		if (who->user == NULL) {
-			/* FIXME: transport */
-			return;
-		}
-		realwho = g_strdup_printf("%s@%s", who->user, who->server);
-	}
-
-	x = xmlnode_new_tag("presence");
-	xmlnode_put_attrib(x, "to", realwho);
-	xmlnode_put_attrib(x, "type", "subscribe");
-	gjab_send(((struct jabber_data *)gc->proto_data)->gjc, x);
-	xmlnode_free(x);
-
-	jabber_roster_update(gc, realwho);
-
-	g_free(realwho);
-}
-
-static void jabber_remove_buddy(struct gaim_connection *gc, char *name, char *group)
-{
-	xmlnode x;
-	char *realwho;
-	gjconn gjc = ((struct jabber_data *)gc->proto_data)->gjc;
-
-	if (!name)
-		return;
-
-	if (!strchr(name, '@'))
-		realwho = g_strdup_printf("%s@%s", name, gjc->user->server);
-	else
-		realwho = g_strdup(name);
-
-	x = xmlnode_new_tag("presence");
-	xmlnode_put_attrib(x, "to", realwho);
-	xmlnode_put_attrib(x, "type", "unsubscribe");
-	gjab_send(((struct jabber_data *)gc->proto_data)->gjc, x);
-	g_free(realwho);
-	xmlnode_free(x);
-}
-
-static void jabber_get_info(struct gaim_connection *gc, char *who) {
-	xmlnode x;
-	char *id;
-	char *realwho;
-	struct jabber_data *jd = gc->proto_data;
-	gjconn gjc = jd->gjc;
-
-	x = jutil_iqnew(JPACKET__GET, NS_VCARD);
-	/* Bare username? */
-	if (!strchr(who, '@')) {
-		realwho = g_strdup_printf("%s@%s", who, gjc->user->server);
-	} else {
-		realwho = g_strdup(who);
-	}
-	xmlnode_put_attrib(x, "to", realwho);
-	g_free(realwho);
-
-	id = gjab_getid(gjc);
-	xmlnode_put_attrib(x, "id", id);
-
-	g_hash_table_insert(jd->gjc->queries, g_strdup(id), g_strdup("vCard"));
-
-	gjab_send(gjc, x);
-
-	xmlnode_free(x);
-	
-}
-
-static void jabber_get_away_msg(struct gaim_connection *gc, char *who) {
-	struct jabber_data *jd = gc->proto_data;
-	gjconn gjc = jd->gjc;
-	char *status;
-
-	/* space for all elements: Jabber I.D. + "status" + NULL (list terminator) */
-	gchar **str_arr = (gchar **) g_new(gpointer, 3);
-	gchar **ap = str_arr;
-	gchar *realwho, *final;
-
-	/* Bare username? */
-	if (!strchr(who, '@')) {
-		realwho = g_strdup_printf("%s@%s", who, gjc->user->server);
-	} else {
-		realwho = g_strdup(who);
-	}
-	*ap++ = g_strdup_printf("<B>Jabber ID:</B> %s<BR>\n", realwho);
-
-	if((status = g_hash_table_lookup(jd->hash, realwho)) == NULL) {
-		status = _("Unknown");
-	}
-	*ap++ = g_strdup_printf("<B>Status:</B> %s<BR>\n", status);
-
-	*ap = NULL;
-
-	final= g_strjoinv(NULL, str_arr);
-	g_strfreev(str_arr);
-
-	g_free(realwho);
-	g_free(final);
-	
-}
-
-static GList *jabber_away_states(struct gaim_connection *gc) {
-	GList *m = NULL;
-
-	m = g_list_append(m, "Online");
-	m = g_list_append(m, "Chatty");
-	m = g_list_append(m, "Away");
-	m = g_list_append(m, "Extended Away");
-	m = g_list_append(m, "Do Not Disturb");
-
-	return m;
-}
-
-static void jabber_set_away(struct gaim_connection *gc, char *state, char *message)
-{
-	xmlnode x, y;
-	struct jabber_data *jd = gc->proto_data;
-	gjconn gjc = jd->gjc;
-
-	gc->away = NULL; /* never send an auto-response */
-
-	x = xmlnode_new_tag("presence");
-
-	if (!strcmp(state, GAIM_AWAY_CUSTOM)) {
-		/* oh goody. Gaim is telling us what to do. */
-		if (message) {
-			/* Gaim wants us to be away */
-			y = xmlnode_insert_tag(x, "show");
-			xmlnode_insert_cdata(y, "away", -1);
-			y = xmlnode_insert_tag(x, "status");
-			xmlnode_insert_cdata(y, message, -1);
-			gc->away = "";
-		} else {
-			/* Gaim wants us to not be away */
-			/* but for Jabber, we can just send presence with no other information. */
-		}
-	} else {
-		/* state is one of our own strings. it won't be NULL. */
-		if (!g_strcasecmp(state, "Online")) {
-			/* once again, we don't have to put anything here */
-		} else if (!g_strcasecmp(state, "Chatty")) {
-			y = xmlnode_insert_tag(x, "show");
-			xmlnode_insert_cdata(y, "chat", -1);
-		} else if (!g_strcasecmp(state, "Away")) {
-			y = xmlnode_insert_tag(x, "show");
-			xmlnode_insert_cdata(y, "away", -1);
-			gc->away = "";
-		} else if (!g_strcasecmp(state, "Extended Away")) {
-			y = xmlnode_insert_tag(x, "show");
-			xmlnode_insert_cdata(y, "xa", -1);
-			gc->away = "";
-		} else if (!g_strcasecmp(state, "Do Not Disturb")) {
-			y = xmlnode_insert_tag(x, "show");
-			xmlnode_insert_cdata(y, "dnd", -1);
-			gc->away = "";
-		}
-	}
-
-	gjab_send(gjc, x);
-	xmlnode_free(x);
-}
-
-static void jabber_keepalive(struct gaim_connection *gc) {
-	struct jabber_data *jd = (struct jabber_data *)gc->proto_data;
-	gjab_send_raw(jd->gjc, "  \t  ");
-}
-
-/*---------------------------------------*/
-/* Jabber "set info" (vCard) support     */
-/*---------------------------------------*/
-
-/*
- * V-Card format:
- *
- *  <vCard prodid='' version='' xmlns=''>
- *    <FN></FN>
- *    <N>
- *	<FAMILY/>
- *	<GIVEN/>
- *    </N>
- *    <NICKNAME/>
- *    <URL/>
- *    <ADR>
- *	<STREET/>
- *	<EXTADD/>
- *	<LOCALITY/>
- *	<REGION/>
- *	<PCODE/>
- *	<COUNTRY/>
- *    </ADR>
- *    <TEL/>
- *    <EMAIL/>
- *    <ORG>
- *	<ORGNAME/>
- *	<ORGUNIT/>
- *    </ORG>
- *    <TITLE/>
- *    <ROLE/>
- *    <DESC/>
- *    <BDAY/>
- *  </vCard>
- *
- * See also:
- *
- *	http://docs.jabber.org/proto/html/vcard-temp.html
- *	http://www.vcard-xml.org/dtd/vCard-XML-v2-20010520.dtd
- */
-
-/*
- * Cross-reference user-friendly V-Card entry labels to vCard XML tags
- * and attributes.
- *
- * Order is (or should be) unimportant.  For example: we have no way of
- * knowing in what order real data will arrive.
- *
- * Format: Label, Pre-set text, "visible" flag, "editable" flag, XML tag
- *         name, XML tag's parent tag "path" (relative to vCard node).
- *
- *         List is terminated by a NULL label pointer.
- *
- *	   Entries with no label text, but with XML tag and parent tag
- *	   entries, are used by V-Card XML construction routines to
- *	   "automagically" construct the appropriate XML node tree.
- *
- * Thoughts on future direction/expansion
- *
- *	This is a "simple" vCard.
- *
- *	It is possible for nodes other than the "vCard" node to have
- *      attributes.  Should that prove necessary/desirable, add an
- *      "attributes" pointer to the vcard_template struct, create the
- *      necessary tag_attr structs, and add 'em to the vcard_dflt_data
- *      array.
- *
- *	The above changes will (obviously) require changes to the vCard
- *      construction routines.
- */
-
-static struct vcard_template {
-	char *label;			/* label text pointer */
-	char *text;			/* entry text pointer */
-	int  visible;			/* should entry field be "visible?" */
-	int  editable;			/* should entry field be editable? */
-	char *tag;			/* tag text */
-	char *ptag;			/* parent tag "path" text */
-	char *url;			/* vCard display format if URL */
-} vcard_template_data[] = {
-	{N_("Full Name"),          NULL, TRUE, TRUE, "FN",        NULL,  NULL},
-	{N_("Family Name"),        NULL, TRUE, TRUE, "FAMILY",    "N",   NULL},
-	{N_("Given Name"),         NULL, TRUE, TRUE, "GIVEN",     "N",   NULL},
-	{N_("Nickname"),           NULL, TRUE, TRUE, "NICKNAME",  NULL,  NULL},
-	{N_("URL"),                NULL, TRUE, TRUE, "URL",       NULL,  "<A HREF=\"%s\">%s</A>"},
-	{N_("Street Address"),     NULL, TRUE, TRUE, "STREET",    "ADR", NULL},
-	{N_("Extended Address"),   NULL, TRUE, TRUE, "EXTADD",    "ADR", NULL},
-	{N_("Locality"),           NULL, TRUE, TRUE, "LOCALITY",  "ADR", NULL},
-	{N_("Region"),             NULL, TRUE, TRUE, "REGION",    "ADR", NULL},
-	{N_("Postal Code"),        NULL, TRUE, TRUE, "PCODE",     "ADR", NULL},
-	{N_("Country"),            NULL, TRUE, TRUE, "COUNTRY",   "ADR", NULL},
-	{N_("Telephone"),          NULL, TRUE, TRUE, "TELEPHONE", NULL,  NULL},
-	{N_("Email"),              NULL, TRUE, TRUE, "EMAIL",     NULL,  "<A HREF=\"mailto:%s\">%s</A>"},
-	{N_("Organization Name"),  NULL, TRUE, TRUE, "ORGNAME",   "ORG", NULL},
-	{N_("Organization Unit"),  NULL, TRUE, TRUE, "ORGUNIT",   "ORG", NULL},
-	{N_("Title"),              NULL, TRUE, TRUE, "TITLE",     NULL,  NULL},
-	{N_("Role"),               NULL, TRUE, TRUE, "ROLE",      NULL,  NULL},
-	{N_("Birthday"),           NULL, TRUE, TRUE, "BDAY",      NULL,  NULL},
-	{N_("Description"),        NULL, TRUE, TRUE, "DESC",      NULL,  NULL},
-	{"", NULL, TRUE, TRUE, "N",     NULL, NULL},
-	{"", NULL, TRUE, TRUE, "ADR",   NULL, NULL},
-	{"", NULL, TRUE, TRUE, "ORG",   NULL, NULL},
-	{NULL, NULL, 0, 0, NULL, NULL, NULL}
-};
-
-/*
- * Used by routines to parse an XML-encoded string into an xmlnode tree
- */
-typedef struct {
-	XML_Parser parser;
-	xmlnode current;
-} *xmlstr2xmlnode_parser, xmlstr2xmlnode_parser_struct;
-
-
-/*
- * Used by XML_Parse on parsing CDATA
- */
-static void xmlstr2xmlnode_charData(void *userdata, const char *s, int slen)
-{
-	xmlstr2xmlnode_parser xmlp = (xmlstr2xmlnode_parser) userdata;
-
-	if (xmlp->current)
-		xmlnode_insert_cdata(xmlp->current, s, slen);
-}
-
-/*
- * Used by XML_Parse to start or append to an xmlnode
- */
-static void xmlstr2xmlnode_startElement(void *userdata, const char *name, const char **attribs)
-{
-	xmlnode x;
-	xmlstr2xmlnode_parser xmlp = (xmlstr2xmlnode_parser) userdata;
-
-	if (xmlp->current) {
-		/* Append the node to the current one */
-		x = xmlnode_insert_tag(xmlp->current, name);
-		xmlnode_put_expat_attribs(x, attribs);
-
-		xmlp->current = x;
-	} else {
-		x = xmlnode_new_tag(name);
-		xmlnode_put_expat_attribs(x, attribs);
-		xmlp->current = x;
-	}
-}
-
-/*
- * Used by XML_Parse to end an xmlnode
- */
-static void xmlstr2xmlnode_endElement(void *userdata, const char *name)
-{
-	xmlstr2xmlnode_parser xmlp = (xmlstr2xmlnode_parser) userdata;
-	xmlnode x;
-
-	if (xmlp->current != NULL && (x = xmlnode_get_parent(xmlp->current)) != NULL) {
-		xmlp->current = x;
-	}
-}
-
-/*
- * Parse an XML-encoded string into an xmlnode tree
- *
- * Caller is responsible for freeing the returned xmlnode
- */
-static xmlnode xmlstr2xmlnode(char *xmlstring)
-{
-	xmlstr2xmlnode_parser my_parser = g_new(xmlstr2xmlnode_parser_struct, 1);
-	xmlnode x = NULL;
-
-	my_parser->parser = XML_ParserCreate(NULL);
-	my_parser->current = NULL;
-
-	XML_SetUserData(my_parser->parser, (void *)my_parser);
-	XML_SetElementHandler(my_parser->parser, xmlstr2xmlnode_startElement, xmlstr2xmlnode_endElement);
-	XML_SetCharacterDataHandler(my_parser->parser, xmlstr2xmlnode_charData);
-	XML_Parse(my_parser->parser, xmlstring, strlen(xmlstring), 0);
-
-	x = my_parser->current;
-
-	XML_ParserFree(my_parser->parser);
-	g_free(my_parser);
-
-	return(x);
-}
-
-/*
- * Insert a tag node into an xmlnode tree, recursively inserting parent tag
- * nodes as necessary
- *
- * Returns pointer to inserted node
- *
- * Note to hackers: this code is designed to be re-entrant (it's recursive--it
- * calls itself), so don't put any "static"s in here!
- */
-static xmlnode insert_tag_to_parent_tag(xmlnode start, const char *parent_tag, const char *new_tag)
-{
-	xmlnode x = NULL;
-
-	/*
-	 * If the parent tag wasn't specified, see if we can get it
-	 * from the vCard template struct.
-	 */
-	if(parent_tag == NULL) {
-		struct vcard_template *vc_tp = vcard_template_data;
-
-		while(vc_tp->label != NULL) {
-			if(strcmp(vc_tp->tag, new_tag) == 0) {
-				parent_tag = vc_tp->ptag;
-				break;
-			}
-			++vc_tp;
-		}
-	}
-
-	/*
-	 * If we have a parent tag...
-	 */
-	if(parent_tag != NULL ) {
-		/*
-		 * Try to get the parent node for a tag
-		 */
-		if((x = xmlnode_get_tag(start, parent_tag)) == NULL) {
-			/*
-			 * Descend?
-			 */
-			char *grand_parent = strcpy(g_malloc(strlen(parent_tag) + 1), parent_tag);
-			char *parent;
-
-			if((parent = strrchr(grand_parent, '/')) != NULL) {
-				*(parent++) = '\0';
-				x = insert_tag_to_parent_tag(start, grand_parent, parent);
-			} else {
-				x = xmlnode_insert_tag(start, grand_parent);
-			}
-			g_free(grand_parent);
-		} else {
-			/*
-			 * We found *something* to be the parent node.
-			 * Note: may be the "root" node!
-			 */
-			xmlnode y;
-			if((y = xmlnode_get_tag(x, new_tag)) != NULL) {
-				return(y);
-			}
-		}
-	}
-
-	/*
-	 * insert the new tag into its parent node
-	 */
-	return(xmlnode_insert_tag((x == NULL? start : x), new_tag));
-}
-
-/*
- * Send vCard info to Jabber server
- */
-static void jabber_set_info(struct gaim_connection *gc, char *info)
-{
-	xmlnode x, vc_node;
-	char *id;
-	struct jabber_data *jd = gc->proto_data;
-	gjconn gjc = jd->gjc;
-
-	x = xmlnode_new_tag("iq");
-	xmlnode_put_attrib(x,"type","set");
-
-	id = gjab_getid(gjc);
-	
-	xmlnode_put_attrib(x, "id", id);
-
-	/*
-	 * Send only if there's actually any *information* to send
-	 */
-	if((vc_node = xmlstr2xmlnode(info)) != NULL && xmlnode_get_name(vc_node) != NULL &&
-			g_strncasecmp(xmlnode_get_name(vc_node), "vcard", 5) == 0) {
-		xmlnode_insert_tag_node(x, vc_node);
-		gjab_send(gjc, x);
-	}
-
-	xmlnode_free(x);
-}
-
-/*
- * displays a Jabber vCard
- */
-static void jabber_handlevcard(gjconn gjc, xmlnode querynode, char *from)
-{
-	struct jabber_data *jd = GJ_GC(gjc)->proto_data;
-	jid who = jid_new(gjc->p, from);
-	char *status = NULL, *text = NULL;
-	GString *str = g_string_sized_new(100);
-	xmlnode child;
-
-	gchar *buddy = NULL;
-	
-	if(querynode == NULL) {
-		serv_got_crap(GJ_GC(gjc), "%s - Received empty info reply from %s", _("User Info"), from);
-		return;
-	}
-
-	if(who->resource != NULL && (who->resource)[0] != '\0') {
-		buddy = g_strdup_printf("%s@%s/%s", who->user, who->server, who->resource);
-	} else {
-		buddy = g_strdup_printf("%s@%s", who->user, who->server);
-	}
-
-	if((status = g_hash_table_lookup(jd->hash, buddy)) == NULL) {
-		status = _("Unknown");
-	}
-
-	g_string_sprintfa(str, "%s: %s - %s: %s", _("Jabber ID"), buddy, _("Status"),
-	                       status);
-
-	for(child = querynode->firstchild; child; child = child->next)
-	{
-		xmlnode child2;
-
-		if(child->type != NTYPE_TAG)
-			continue;
-
-		text = xmlnode_get_data(child);
-		if(text && !strcmp(child->name, "FN")) {
-			info_string_append(str, "\n", _("Full Name"), text);
-		} else if (!strcmp(child->name, "N")) {
-			for (child2 = child->firstchild; child2; child2 = child2->next) {
-				char *text2 = NULL;
-
-				if (child2->type != NTYPE_TAG)
-					continue;
-
-				text2 = xmlnode_get_data(child2);
-				if (text2 && !strcmp(child2->name, "FAMILY")) {
-					info_string_append(str, "\n", _("Family Name"), text2);
-				} else if (text2 && !strcmp(child2->name, "GIVEN")) {
-					info_string_append(str, "\n", _("Given Name"), text2);
-				} else if (text2 && !strcmp(child2->name, "MIDDLE")) {
-					info_string_append(str, "\n", _("Middle Name"), text2);
-				}
-			}
-		} else if (text && !strcmp(child->name, "NICKNAME")) {
-			info_string_append(str, "\n", _("Nickname"), text);
-		} else if (text && !strcmp(child->name, "BDAY")) {
-			info_string_append(str, "\n", _("Birthday"), text);
-		} else if (!strcmp(child->name, "ADR")) {
-			/* show wich address it is */
-			/* Just for the beauty of bitlbee 
-			if (child->firstchild)
-				g_string_sprintfa(str, "%s:\n", _("Address"));
-			*/
-			for(child2 = child->firstchild; child2; child2 = child2->next) {
-				char *text2 = NULL;
-
-				if(child2->type != NTYPE_TAG)
-					continue;
-
-				text2 = xmlnode_get_data(child2);
-				if(text2 && !strcmp(child2->name, "POBOX")) {
-					info_string_append(str, "\n",
-							_("P.O. Box"), text2);
-				} else if(text2 && !strcmp(child2->name, "EXTADR")) {
-					info_string_append(str, "\n",
-							_("Extended Address"), text2);
-				} else if(text2 && !strcmp(child2->name, "STREET")) {
-					info_string_append(str, "\n",
-							_("Street Address"), text2);
-				} else if(text2 && !strcmp(child2->name, "LOCALITY")) {
-					info_string_append(str, "\n",
-							_("Locality"), text2);
-				} else if(text2 && !strcmp(child2->name, "REGION")) {
-					info_string_append(str, "\n",
-							_("Region"), text2);
-				} else if(text2 && !strcmp(child2->name, "PCODE")) {
-					info_string_append(str, "\n",
-							_("Postal Code"), text2);
-				} else if(text2 && (!strcmp(child2->name, "CTRY")
-							|| !strcmp(child2->name, "COUNTRY"))) {
-					info_string_append(str, "\n", _("Country"), text2);
-				}
-			}
-		} else if(!strcmp(child->name, "TEL")) {
-			char *number = NULL;
-			if ((child2 = xmlnode_get_tag(child, "NUMBER"))) {
-				/* show what kind of number it is */
-				number = xmlnode_get_data(child2);
-				if(number) {
-					info_string_append(str, "\n", _("Telephone"), number);
-				}
-			} else if((number = xmlnode_get_data(child))) {
-				/* lots of clients (including gaim) do this,
-				 * but it's out of spec */
-				info_string_append(str, "\n", _("Telephone"), number);
-			}
-		} else if(!strcmp(child->name, "EMAIL")) {
-			char *userid = NULL;
-			if((child2 = xmlnode_get_tag(child, "USERID"))) {
-				/* show what kind of email it is */
-				userid = xmlnode_get_data(child2);
-				if(userid) {
-					info_string_append(str, "\n", _("Email"), userid);
-				}
-			} else if((userid = xmlnode_get_data(child))) {
-				/* lots of clients (including gaim) do this,
-				 * but it's out of spec */
-				info_string_append(str, "\n", _("Email"), userid);
-			}
-		} else if(!strcmp(child->name, "ORG")) {
-			for(child2 = child->firstchild; child2; child2 = child2->next) {
-				char *text2 = NULL;
-
-				if(child2->type != NTYPE_TAG)
-					continue;
-
-				text2 = xmlnode_get_data(child2);
-				if(text2 && !strcmp(child2->name, "ORGNAME")) {
-					info_string_append(str, "\n", _("Organization Name"), text2);
-				} else if(text2 && !strcmp(child2->name, "ORGUNIT")) {
-					info_string_append(str, "\n", _("Organization Unit"), text2);
-				}
-			}
-		} else if(text && !strcmp(child->name, "TITLE")) {
-			info_string_append(str, "\n", _("Title"), text);
-		} else if(text && !strcmp(child->name, "ROLE")) {
-			info_string_append(str, "\n", _("Role"), text);
-		} else if(text && !strcmp(child->name, "DESC")) {
-			g_string_sprintfa(str, "\n%s:\n%s\n%s", _("Description"), 
-					text, _("End of Description"));
-		}
-	}
-
-	serv_got_crap(GJ_GC(gjc), "%s\n%s", _("User Info"), str->str);
-
-	g_free(buddy);
-	g_string_free(str, TRUE);
-}
-
 void jabber_init()
 {
-	struct prpl *ret = g_new0(struct prpl, 1);
-
+	struct prpl *ret = g_new0( struct prpl, 1 );
+	
 	ret->name = "jabber";
-	ret->away_states = jabber_away_states;
+	ret->login = jabber_login;
 	ret->acc_init = jabber_acc_init;
-	ret->login = jabber_login;
 	ret->close = jabber_close;
 	ret->send_im = jabber_send_im;
-	ret->set_info = jabber_set_info;
+	ret->away_states = jabber_away_states;
+//	ret->get_status_string = jabber_get_status_string;
+	ret->set_away = jabber_set_away;
+//	ret->set_info = jabber_set_info;
 	ret->get_info = jabber_get_info;
-	ret->set_away = jabber_set_away;
-	ret->get_away = jabber_get_away_msg;
 	ret->add_buddy = jabber_add_buddy;
 	ret->remove_buddy = jabber_remove_buddy;
+//	ret->chat_send = jabber_chat_send;
+//	ret->chat_invite = jabber_chat_invite;
+//	ret->chat_leave = jabber_chat_leave;
+//	ret->chat_open = jabber_chat_open;
 	ret->keepalive = jabber_keepalive;
-	ret->alias_buddy = jabber_roster_update;
-	ret->group_buddy = jabber_group_change;
+	ret->send_typing = jabber_send_typing;
 	ret->handle_cmp = g_strcasecmp;
 
-	register_protocol (ret);
-}
+	register_protocol( ret );
+}
